/***********************************************************

	pic24seg7.c

	Version 0.91: 2009/02/12

	Copyright (C) 2008-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

#include "picsys24.h"
#include <stdlib.h>


static byte _u1RxBuffer[RX_BUFFER_SIZE] ;
static int _u1RxHead = -1;
static int _u1RxTail ;

void __pinMode(byte pin, byte mode) ;


/***********************************************************
	VAC̏
***********************************************************/

void
Serial1_begin(long baud)
{
    /* PIC24FI/Ost(Remappable Peripheral) */
#if defined(PIC24F_MOD_GA002U)
    RPINR18bits.U1RXR = 12;  /* RP12U1RXɐݒ */
    RPOR6bits.RP13R = 3;     /* RP13U1TXɐݒ */
#endif

#if defined(DUO_GL128_PIC24F)
    RPINR18bits.U1RXR = 15;  /* RP15U1RXɐݒ */
    RPOR7bits.RP14R = 3;     /* RP14U1TXɐݒ */
//    __pinMode(RB(15), INPUT) ;
//    __pinMode(RB(14), OUTPUT) ;
#endif

	_u1RxHead = 0 ;
	_u1RxTail = 0 ;

    /* UART1̐ݒ */
	U1BRG = ((F_CPU / 2 / baud) / 16) - 1 ;
	U1MODE = 0b1000100000000000 ;
	U1STA = 0b0000010000000000 ;
}


/***********************************************************
	VAC̒~
***********************************************************/

void
Serial1_end()
{
#if defined(PIC24F_MOD_GA002U)
    RPINR18bits.U1RXR = 0x1f;  /* RP12UNMAPɐݒ */
    RPOR6bits.RP13R = 0;     /* RP13NULLɐݒ */
#endif

#if defined(DUO_GL128_PIC24F)
    RPINR18bits.U1RXR = 0x1f;  /* RP15UNMAPɐݒ */
    RPOR7bits.RP14R = 0;     /* RP14NULLɐݒ */
#endif
	_u1RxHead = -1 ;

	U1MODE = 0b0000000000000000 ;
}


/***********************************************************
	̎M
***********************************************************/

int
Serial1_getc()
{
#ifdef USE_SERIAL_INT
	byte c ;
	
	if (_u1RxHead == _u1RxTail)
		return -1 ;

	c = _u1RxBuffer[_u1RxTail] ;

	_u1RxTail = (_u1RxTail + 1) & (RX_BUFFER_SIZE - 1) ;

	return c ;
#else
	if (!U1STAbits.URXDA)
		return -1 ;

	return U1RXREG & 0xff ;
#endif

}


/***********************************************************
	̑M
***********************************************************/

void
Serial1_putc(char c)
{
	while (U1STAbits.UTXBF)
		;

	U1TXREG = c ;
}


/***********************************************************
	̑M
***********************************************************/

void
Serial1_puts(char *s)
{
	while (*s) {
		while (Serial1_busy())
			;
		Serial1_putc(*s++) ;
	}
}


unsigned int
Serial1_busy()
{
	return U1STAbits.UTXBF ;
}


int
Serial1_available()
{
#ifdef USE_SERIAL_INT
	int i ;

	i = _u1RxHead - _u1RxTail ;

	if (i < 0)
		i += RX_BUFFER_SIZE ;

	return i ;
#else
	return U1STAbits.URXDA ;
#endif
}


/***********************************************************
	荞݂ł̎Mobt@̃|[OFM荞݂Ɋ
***********************************************************/

void
_uxRxPolling()
{
#ifdef USE_SERIAL_INT
	if (_u1RxHead >= 0) {
		while (U1STAbits.URXDA) {
			if (((_u1RxHead + 1) & (RX_BUFFER_SIZE - 1)) == _u1RxTail) {
				// Overrun
//				_u1RxTail++ ;
//				_u1RxTail &= (RX_BUFFER_SIZE - 1) ;
			}
			_u1RxBuffer[_u1RxHead++] = U1RXREG ;
			_u1RxHead &= (RX_BUFFER_SIZE - 1) ;
		}
	}
#endif
}
