/***********************************************************

	picsys24.c

	Version 0.91: 2009/02/12

	Copyright (C) 2008-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

#include "picsys24.h"


/***********************************************************
	CONFIGݒ
***********************************************************/

/*
JTAGEN_OFF	JTAG
GCP_OFF		R[hی얳
GWRP_OFF	R[htbVݕی얳
BKBUG_OFF	obNOEhfobO
ICS_PGx2	EMUC/EMUDsPGC2/PGD2Ƌp
FWDTEN_OFF	EHb`hbO^C}
WINDIS_OFF	tEHb`hbO^C}
*/
_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_OFF &
	COE_OFF & ICS_PGx2 & FWDTEN_OFF)

/*
IESO_OFF		2ixX^[gAbv
FNOSC_PRIPLL	唭U+PLL
FCKSM_CSDCMD	NbN؂ւANbNj^
OSCIOFNC_OFF	OSCsCLKO
IOL1WAY_ON		OSCCON͏݉\
I2C1SEL			picsys24conf.hőI
POSCMOD_XT		XTU[h
*/
#if (XTAL_OSC == 32 MHz)
_CONFIG2(IESO_OFF & FNOSC_PRIPLL & FCKSM_CSDCMD & OSCIOFNC_OFF &
	IOL1WAY_OFF & I2C1SEL & POSCMOD_XT);
#elif (XTAL_OSC == 8 MHz)
_CONFIG2(IESO_OFF & FNOSC_PRI & FCKSM_CSDCMD & OSCIOFNC_OFF &
	IOL1WAY_OFF & I2C1SEL & POSCMOD_XT);
#elif (INT_OSC == 32 MHz)
_CONFIG2(IESO_OFF & FNOSC_FRCPLL & FCKSM_CSDCMD & OSCIOFNC_OFF &
	IOL1WAY_OFF & I2C1SEL & POSCMOD_NONE);
#elif (INT_OSC == 8 MHz)
_CONFIG2(IESO_OFF & FNOSC_FRC & FCKSM_CSDCMD & OSCIOFNC_OFF &
	IOL1WAY_OFF & I2C1SEL & POSCMOD_NONE);
#else
#error NX^̎gݒ肪ԈĂ܂
#endif


/***********************************************************
	O[oϐ`
***********************************************************/

static const byte _adMap[] = {RA(0), RA(1), RB(0), RB(1), RB(2), RB(3), NO_ASSIGN, NO_ASSIGN,
		NO_ASSIGN, RB(15), RB(14), RB(13), RB(12)} ;

#if defined(__PIC24FJ64GA002__) || defined(__PIC24FJ64GA004__)
static const byte _cnpuMapA[16] = {2, 3, 30, 29, 0, NO_ASSIGN, NO_ASSIGN, NO_ASSIGN,
		NO_ASSIGN, NO_ASSIGN, NO_ASSIGN, NO_ASSIGN, NO_ASSIGN, NO_ASSIGN, NO_ASSIGN, NO_ASSIGN} ;
static const byte _cnpuMapB[16] = {4, 5, 6, 7, 1, 27, 24, 23,
		22, 21, 16, 15, 14, 13, 12, 11} ;
#endif
#if defined(__PIC24FJ64GA004__)
static const byte _cnpuMapC[16] = {8, 9, 10, 28, 25, 26, 18, 17,
		20, 19, NO_ASSIGN, NO_ASSIGN, NO_ASSIGN, NO_ASSIGN, NO_ASSIGN, NO_ASSIGN} ;
#endif


byte _beepPin = NO_ASSIGN ;
byte _beepValue ;

byte _pwmPin[4] = {NO_ASSIGN, NO_ASSIGN, NO_ASSIGN, NO_ASSIGN} ;
byte _pwmValue[4] ;

byte _servoPin[4] = {NO_ASSIGN, NO_ASSIGN, NO_ASSIGN, NO_ASSIGN} ;
byte _servoDisable = 0x00 ;
int _servoValue[4] ;
int _servoMin[4] = {-100, -100, -100, -100} ;
int _servoMax[4] = {100, 100, 100, 100} ;


/***********************************************************
	VXȅ
***********************************************************/

static void
_initPicsys(void)
{
#if defined(DOZE_MODE2)
	CLKDIVbits.ROI = 1 ;
	CLKDIVbits.DOZE = 1 ; // 1/2
#elif defined(DOZE_MODE4)
	CLKDIVbits.ROI = 1 ;
	CLKDIVbits.DOZE = 2 ; // 1/4
#elif defined(DOZE_MODE8)
	CLKDIVbits.ROI = 1 ;
	CLKDIVbits.DOZE = 3 ; // 1/8
#elif defined(DOZE_MODE16)
	CLKDIVbits.ROI = 1 ;
	CLKDIVbits.DOZE = 4 ; // 1/16
#elif defined(DOZE_MODE32)
	CLKDIVbits.ROI = 1 ;
	CLKDIVbits.DOZE = 5 ; // 1/32
#else
	CLKDIVbits.DOZE = 0 ; // 1/1
#endif
	CLKDIVbits.DOZEN = 1 ; 

	/* AiO͂fW^͂ */
    AD1PCFG = 0xffff;        /* AiOsׂăfW^ɕύX */

	TIMER4_init() ;
}


/***********************************************************
	C֐
***********************************************************/

int
main(void)
{
	_initPicsys() ;
#if defined(DUO_GL128_PIC24F)
//	SW_init() ;
#endif

	setup() ;

	for (;;)
		loop() ;
	
	return 0 ;
}


/***********************************************************
	XCb`̏
***********************************************************/

#if defined(DUO_GL128_PIC24F)
static byte __sw[8] ;

void
SW_init()
{
	pinMode(SW_ACTIVATE1, OUTPUT) ;
	pinMode(SW_ACTIVATE2, OUTPUT) ;
	digitalWrite(SW_ACTIVATE1, HIGH) ;
	digitalWrite(SW_ACTIVATE2, HIGH) ;

	__sw[0] = 0xff ;
	__sw[1] = 0xff ;
	__sw[2] = 0xff ;
	__sw[3] = 0xff ;
	__sw[4] = 0xff ;
	__sw[5] = 0xff ;
	__sw[6] = 0xff ;
	__sw[7] = 0xff ;
}


#if 1
void
isr_SW_update()
{
	unsigned int bs_trisb ;
	byte bs_act1, bs_act2 ;

	bs_trisb = TRISB ;
	bs_act1 = OPT_SW_ACTIVATE1 ;
	bs_act2 = OPT_SW_ACTIVATE2 ;
	
	TRISB |= OPT_SW_MASK ;
	CNPU1 |= 0b0000000011110010 ;
	CNPU2 |= 0b0000100110000000 ;

	OPT_SW_ACTIVATE1 = 0 ;
	OPT_SW_ACTIVATE2 = 0 ;

	Nop() ; Nop() ; Nop() ; Nop() ;

	__sw[0] = OPT_SW1 ;
	__sw[1] = OPT_SW2 ;
	__sw[2] = OPT_SW3 ;
	__sw[3] = OPT_SW4 ;
	__sw[4] = OPT_SW5 ;
	__sw[5] = OPT_SW6 ;
	__sw[6] = OPT_SW7 ;
	__sw[7] = OPT_SW8 ;

	OPT_SW_ACTIVATE1 = bs_act1 ;
	OPT_SW_ACTIVATE2 = bs_act2 ;

	TRISB = bs_trisb ;
/*
  pinMode(diPin, INPUT) ;
  // USB̐ڑԂ擾
  connectUSB = digitalRead(diPin) ? true : false ;
  pinMode(diPin, OUTPUT) ;
*/
}
#else
extern byte dataPin, clockPin ;
#if defined(USE_SEG7)
extern byte segDigit[] ;
#elif defined(USE_DML)
extern byte ePin ;
extern byte dbPin[3] ;
#endif

void
isr_SW_update()
{
	char i ;

#if defined(USE_SEG7)
    for (i = 0; i < NSEG; i++)
		pinMode(segDigit[i], INPUT) ;
#elif defined(USE_DML)
    for (i = 0; i < NSEG-1; i++)
		pinMode(dbPin[i], INPUT) ;
	pinMode(ePin, INPUT) ;
#endif

	pinMode(dataPin, INPUT) ;

	isr_digitalWrite(SW_ACTIVATE1, LOW) ;
	isr_digitalWrite(SW_ACTIVATE2, LOW) ;

	__sw[0] = digitalRead(SW1) ;
	__sw[1] = digitalRead(SW2) ;
	__sw[2] = digitalRead(SW3) ;
	__sw[3] = digitalRead(SW4) ;
	__sw[4] = digitalRead(SW5) ;
	__sw[5] = digitalRead(SW6) ;
	__sw[6] = digitalRead(SW7) ;
	__sw[7] = digitalRead(SW8) ;

	isr_digitalWrite(SW_ACTIVATE1, HIGH) ;

#if defined(USE_SEG7)
    for (i = 0; i < NSEG; i++)
		pinMode(segDigit[i], OUTPUT) ;
#elif defined(USE_DML)
    for (i = 0; i < NSEG-1; i++)
		pinMode(dbPin[i], OUTPUT) ;
	pinMode(ePin, OUTPUT) ;
#endif
	pinMode(dataPin, OUTPUT) ;
}
#endif

byte
SW_read(byte n)
{
	return __sw[n] & 1 ;
}

#endif


/***********************************************************
	sI/O
***********************************************************/

void
pinMode(byte pin, byte mode)
{
	int i ;
	unsigned int b, cb ;
	volatile unsigned int *tp, *op, *cp ;

/* Ys̋@\ */
	/* AiO̖͂ */
	for (i = 0; i < sizeof(_adMap)/sizeof(byte); i++)
		if (_adMap[i] == pin) {
			AD1PCFG |= BIT(i) ;
			break ;
		}

	/* r[v@\̉ */
	if (pin == _beepPin) {
		_beepPin = NO_ASSIGN ;
		digitalWrite(pin, LOW) ; // dȂ悤
	}

	/* PWM@\̉ */
	for (i = 0; i < sizeof(_pwmPin)/sizeof(byte); i++)
		if (_pwmPin[i] == pin)
			_pwmPin[i] = NO_ASSIGN ;

	/* T[{@\̉ */
	for (i = 0; i < sizeof(_servoPin)/sizeof(byte); i++)
		if (_servoPin[i] == pin) {
			noInterrupts() ;
			_servoDisable |= BIT(i) ;
			interrupts() ;
		}

/* Ys̋@\̍ĐݒJn */
	if (mode >= 5) {
		/* ݒ肾G̓Iȏ͊荞݃T[rX[` */
		if (mode == OUT_BEEP) {
			_beepPin = pin ;
			_beepValue = 0 ;
			digitalWrite(pin, LOW) ;
		} else if (isPWM(mode)) {
			_pwmPin[mode & 0b11] = pin ;
			_pwmValue[mode & 0b11] = 0 ;
		} else if (isSERVO(mode)) {
			_servoPin[mode & 0b11] = pin ;
			_servoValue[mode & 0b11] = 0 ;
/*
			_servoMin[mode & 0b11] = -100 ;
			_servoMax[mode & 0b11] = 100 ;
*/
		}

		mode = OUTPUT ;
	}

	/* ws̑ΉrbgZo */
	b = BIT(pin & 0b00001111) ;
	/* ws̓o̓[hݒ */
	tp = &TRISA + (GET_PORT(pin) - 2) * 4 ;
	op = &ODCA + (GET_PORT(pin) - 2) * 4 ;
	
	cp = 0 ;
	if ((mode == INPUT) || (mode == INPUT_PU)) {
		cb = 0 ; // KvȂǂ邳xߏ
		if (GET_PORT(pin) == ID_PORTA) {
			cb = _cnpuMapA[pin & 0b00001111] ;
			if (cb != NO_ASSIGN)
				cp = (cb >= 16) ? &CNPU2 : &CNPU1 ;
		} else if (GET_PORT(pin) == ID_PORTB) {
			cb = _cnpuMapB[pin & 0b00001111] ;
			if (cb != NO_ASSIGN)
				cp = (cb >= 16) ? &CNPU2 : &CNPU1 ;
#if defined(__PIC24FJ64GA004__)
		} else if (GET_PORT(pin) == ID_PORTC) {
			cb = _cnpuMapC[pin & 0b00001111] ;
			if (cb != NO_ASSIGN)
				cp = (cb >= 16) ? &CNPU2 : &CNPU1 ;
#endif
		}

		if (mode == INPUT) {
			(*tp) |= b ;
			if (cp != 0)
				(*cp) &= ~BIT(cb & 0b00001111) ;
		} else if (mode == INPUT_PU) {
			(*tp) |= b ;
			if (cp != 0)
				(*cp) |= BIT(cb & 0b00001111) ;
		}		
	} else if (mode == OUTPUT) {
		(*tp) &= ~b ;
		(*op) &= ~b ;
	} else if (mode == OUTPUT_OD) {
		(*tp) &= ~b ;
		(*op) |= b ;
	}
}


void
__pinMode(byte pin, byte mode)
{
	unsigned int b, cb ;
	volatile unsigned int *tp, *op, *cp ;

	/* ws̑ΉrbgZo */
	b = BIT(pin & 0b00001111) ;
	/* ws̓o̓[hݒ */
	tp = &TRISA + (GET_PORT(pin) - 2) * 4 ;
	op = &ODCA + (GET_PORT(pin) - 2) * 4 ;
	
	cp = 0 ;
	if ((mode == INPUT) || (mode == INPUT_PU)) {
		cb = 0 ; // KvȂǂ邳xߏ
		if (GET_PORT(pin) == ID_PORTA) {
			cb = _cnpuMapA[pin & 0b00001111] ;
			if (cb != NO_ASSIGN)
				cp = (cb >= 16) ? &CNPU2 : &CNPU1 ;
		} else if (GET_PORT(pin) == ID_PORTB) {
			cb = _cnpuMapB[pin & 0b00001111] ;
			if (cb != NO_ASSIGN)
				cp = (cb >= 16) ? &CNPU2 : &CNPU1 ;
#if defined(__PIC24FJ64GA004__)
		} else if (GET_PORT(pin) == ID_PORTC) {
			cb = _cnpuMapC[pin & 0b00001111] ;
			if (cb != NO_ASSIGN)
				cp = (cb >= 16) ? &CNPU2 : &CNPU1 ;
#endif
		}

		if (mode == INPUT) {
			(*tp) |= b ;
			if (cp != 0)
				(*cp) &= ~BIT(cb & 0b00001111) ;
		} else if (mode == INPUT_PU) {
			(*tp) |= b ;
			if (cp != 0)
				(*cp) |= BIT(cb & 0b00001111) ;
		}		
	} else if (mode == OUTPUT) {
		(*tp) &= ~b ;
		(*op) &= ~b ;
	} else if (mode == OUTPUT_OD) {
		(*tp) &= ~b ;
		(*op) |= b ;
	}
}


void
digitalWrite(byte pin, int value)
{
	int i ;
	unsigned int b ;
	volatile unsigned int *p ;

	/* r[v蓖ăs */
	if (pin == _beepPin) {
		if (value > 8)
			_beepValue = 8 ;
		else if (value < 0)
			_beepValue = 0 ;
		else
			_beepValue = value ;

		return ;
	}

	/* PWM蓖ăs */
	for (i = 0; i < sizeof(_pwmPin)/sizeof(byte); i++)
		if (_pwmPin[i] == pin) {
			if (value < 0)
				value = 0 ;
#if HEART_BEAT == 4 KHz
			if (value >= 100)
				_pwmValue[i] = 64 ;
			else
				_pwmValue[i] = value * 64 / 100 ;
#elif HEART_BEAT == 2 KHz
			if (value >= 100)
				_pwmValue[i] = 32 ;
			else
				_pwmValue[i] = value * 32 / 100 ;
#else
			if (value >= 100)
				_pwmValue[i] = 16 ;
			else
				_pwmValue[i] = value * 16 / 100;
#endif
			return ;
		}

	/* T[{蓖ăs */
	for (i = 0; i < sizeof(_servoPin)/sizeof(byte); i++)
		if (_servoPin[i] == pin) {
			if (value > _servoMax[i])
				_servoValue[i] = _servoMax[i] ;
			else if (value < _servoMin[i])
				_servoValue[i] = _servoMin[i] ;
			else
				_servoValue[i] = value ;

			return ;
		}

	/* ws̑ΉrbgZo */
	b = BIT(pin & 0b00001111) ;

	/* wsɒlo */
	p = &LATA + (GET_PORT(pin) - 2) * 4 ;
	if (value == 0) {
		(*p) &= ~b ;
	} else {
		(*p) |= b ;
	}
}


void
bitOut(byte pin, int value)
{
	unsigned int b ;
	volatile unsigned int *p ;

	/* ws̑ΉrbgZo */
	b = BIT(pin & 0b00001111) ;

	/* wsɒlo */
	p = &LATA + (GET_PORT(pin) - 2) * 4 ;
	if (value == 0) {
		(*p) &= ~b ;
	} else {
		(*p) |= b ;
	}

}


void
isr_bitOut(byte pin, int value)
{
	unsigned int b ;
	volatile unsigned int *p ;

	/* ws̑ΉrbgZo */
	b = BIT(pin & 0b00001111) ;

	/* wsɒlo */
	p = &LATA + (GET_PORT(pin) - 2) * 4 ;
	if (value == 0) {
		(*p) &= ~b ;
	} else {
		(*p) |= b ;
	}
}


int
digitalRead(byte pin)
{
	int i ;
	unsigned int b ;
	volatile unsigned int *p ;

	if (pin == _beepPin)
		return _beepValue ;

	for (i = 0; i < sizeof(_pwmPin)/sizeof(byte); i++)
		if (_pwmPin[i] == pin) {
#if HEART_BEAT == 4 KHz
			if (_pwmValue[i] == 64)
				return 100 ;
			return _pwmValue[i] * 100 / 64 ;
#elif HEART_BEAT == 2 KHz
			if (_pwmValue[i] == 32)
				return 100 ;
			return _pwmValue[i] * 100 / 32 ;
#else
			if (_pwmValue[i] == 16)
				return 100 ;
			return _pwmValue[i] * 100 / 16 ;
#endif
		}

	for (i = 0; i < sizeof(_servoPin)/sizeof(byte); i++)
		if (_servoPin[i] == pin)
			return _servoValue[i] ;

	/* ws|[g̓ǂݏo */
	switch (GET_PORT(pin)) {
#if defined(DUO_GL128_PIC24F)
		/* zXCb` */
		case ID_VSW:
			return __sw[(pin & 0b00001111)] ? 1 : 0 ;
			break ;		
#endif
		default:
			p = &PORTA + (GET_PORT(pin) - 2) * 4 ;
			b = *p ;
			break ;
	}

	/* ws̓͒l擾 */
	return 1 & (b >> (pin & 0b00001111)) ;
}


/***********************************************************
	AiOsI/O
***********************************************************/

/* b菈F傫ς\ */
void
analogWrite(byte pin, int value)
{
	int i ;

	if (pin == _beepPin) {
		if (value > 8)
			_beepValue = 8 ;
		else if (value < 0)
			_beepValue = 0 ;
		else
			_beepValue = value ;
		
		return ;
	}

	for (i = 0; i < sizeof(_pwmPin)/sizeof(byte); i++)
		if (_pwmPin[i] == pin) {
#if HEART_BEAT == 2000 Hz
			_pwmValue[i] = (value >> 3) & 0b11111 ;
#else
			_pwmValue[i] = (value >> 4) & 0b1111 ;
#endif
			return ;
		}

	for (i = 0; i < sizeof(_servoPin)/sizeof(byte); i++)
		if (_servoPin[i] == pin) {
			if (value > _servoMax[i])
				_servoValue[i] = _servoMax[i] ;
			else if (value < _servoMin[i])
				_servoValue[i] = _servoMin[i] ;
			else
				_servoValue[i] = value ;

			return ;
		}
}


static byte _vref = 0 ;

int
analogRead(byte pin)
{
	int v ;

	/* AiOs */
	if (!isAN(pin))
		return 0 ;

	/* LȃAiOsH */
	if (_adMap[pin] == NO_ASSIGN)
		return 0 ;

	/* AiOsnCCs[_X */
	__pinMode(_adMap[pin], INPUT) ;
	/* AiOsɐݒ */
	AD1PCFG &= ~BIT(pin) ;

	AD1CHSbits.CH0SA = pin ;
	
	// ADFM, ACQT, ADCS
	AD1CON1bits.FORM = 0 ;
	AD1CON1bits.SSRC = 0b111 ;

	AD1CON2bits.VCFG = _vref ;
	AD1CON3bits.SAMC = 0x1f ;
	AD1CON3bits.ADCS = 2 ;

	AD1CON1bits.ADON = 1 ;

	AD1CON1bits.SAMP = 1 ;

	while (!AD1CON1bits.DONE)
		;

	v = ADC1BUF0 ;

	AD1CON1bits.ADON = 0 ;

	return v ;
}


void
analogReference(byte type)
{
	pinMode(_adMap[AN(0)], INPUT) ;
	AD1PCFG &= ~BIT(0) ;

	if (type == DEFAULT)
		_vref = 0 ;
	else if (type == EXTERNAL)
		_vref = 1 ;
}


/***********************************************************
	VAf[^o͏
***********************************************************/

#ifdef	OPTIMIZE

void
isr_optShiftOut(byte order, byte value)
{
	unsigned int b, i, v ;

	for (i = 0; i < 8; i++)  {
		v = value & ((order == LSBFIRST) ? 1 : 0b10000000) ;

		OPT_SR_DAT = v ? 1 : 0 ;
		OPT_SR_CLK = 1 ;
		OPT_SR_CLK = 0 ;

		if (order == LSBFIRST)
			value >>= 1 ;
		else
			value <<= 1 ;
	}
}

#endif


void
shiftOut(byte data, byte clock, byte order, byte value)
{
	unsigned int db, cb, i, v ;
	volatile unsigned int *dp, *cp ;

	dp = &LATA + (GET_PORT(data) - 2) * 4 ;
	db = BIT(data & 0b00001111) ;
	cp = &LATA + (GET_PORT(clock) - 2) * 4 ;
	cb = BIT(clock & 0b00001111) ;

	for (i = 0; i < 8; i++)  {
		v = value & ((order == LSBFIRST) ? 1 : 0b10000000) ;

		/* f[^s */
		if (v == 0) {
			(*dp) &= ~db ;
		} else {
			(*dp) |= db ;
		}

		/* NbNs */
		(*cp) |= cb ;
		(*cp) &= ~cb ;

		if (order == LSBFIRST)
			value >>= 1 ;
		else
			value <<= 1 ;
	}
}


/***********************************************************
	l->ϊ֐
***********************************************************/

int
ltos(char buf[], long n, byte base)
{
	char rbuf[12] ;
	int i, j ;
	byte minus = FALSE ;

	/* 0͓ */
	if (n == 0) {
		buf[0] = '0';
		buf[1] = '\0';

		return 1;
	}

	/* 10ȉꍇ̂ݕ̒l̏ */
	if ((base == 10) && (n < 0)) {
		minus = TRUE ;
		n = -n ;
	}

	/* W16rbgɐ؂藎Ƃ */
	if (base < 8)
		n &= 0xffff ;

	for (i = 0; n > 0; i++) {
		j = n % base;
		if (j > 9) {
			rbuf[i] = j + ('A' - 10) ;
		} else {
			rbuf[i] = j + '0' ;
		}
		n /= base;
	}

	j = 0 ;
	if (minus)
		buf[j++] = '-' ;

	while (i > 0)
		buf[j++] = rbuf[--i] ;

	buf[j] = '\0' ;

	return j ;
}
