/***********************************************************

	picsys24.h

	Version 0.91: 2009/02/12

	Copyright (C) 2008-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

#ifndef PICSYS24_H_
#define PICSYS24_H_

#include <p24Fxxxx.h>
#include <Generic.h>

#define	MHz	*1000000UL
#define	KHz	*1000UL
#define	Hz	*1UL

#include "picsys24conf.h"


#if defined(XTAL_OSC)
#define	F_CPU	XTAL_OSC
#elif defined(INT_OSC)
#define	F_CPU	INT_OSC
#else
#error MƎg̎w肪܂
#endif

#if F_CPU >= 16 MHz
#define	HEART_BEAT	(4 KHz)
#elif F_CPU >= 8 MHz
#define	HEART_BEAT	(2 KHz)
#else
#define	HEART_BEAT	(1 KHz)
#endif

/************************************************/

/*
#define	TRUE	1
#define	FALSE	0
*/

#define	HIGH	1
#define	LOW		0

typedef unsigned char byte ;

#define	BIT(n)	(0b1 << (n))


/*------------------------------------------------
	I/O|[g̒`
------------------------------------------------*/

#define	ID_ANL	0
#define	ID_ANH	1
#define	ID_PORTA	2
#define	ID_PORTB	3
#define	ID_PORTC	4
#define	ID_PORTD	5
#define	ID_PORTE	6
#define	ID_PORTF	7
#define	ID_PORTG	8

#define	ID_VSW	14

#define	NO_ASSIGN	0xff

#define	isAN(n)	((n & 0b11110000) == 0b0000000)

#define	AN(pin)	(pin)

#define	GET_PORT(pin)	(pin >> 4)

#define	RA(pin)	((ID_PORTA << 4) | pin)
#define	RB(pin)	((ID_PORTB << 4) | pin)
#define	RC(pin)	((ID_PORTC << 4) | pin)
#define	RD(pin)	((ID_PORTD << 4) | pin)
#define	RE(pin)	((ID_PORTE << 4) | pin)
#define	RF(pin)	((ID_PORTE << 4) | pin)
#define	RG(pin)	((ID_PORTE << 4) | pin)
#define	VSW(pin)	((ID_VSW << 4) | pin)


/*------------------------------------------------
	s[h̒`
------------------------------------------------*/

#define	INPUT 1
#define	OUTPUT 0
#define	OUTPUT_OD	2
#define	INPUT_PU	3

#define	IN_ANALOG	4

#define	OUT_BEEP	5

#define	OUT_PWM1	0b1000
#define	OUT_PWM2	0b1001
#define	OUT_PWM3	0b1010
#define	OUT_PWM4	0b1011
#define	OUT_SERVO1	0b1100
#define	OUT_SERVO2	0b1101
#define	OUT_SERVO3	0b1110
#define	OUT_SERVO4	0b1111

#define	isPWM(n)	((n & 0b1100) == 0b1000)
#define	isSERVO(n)	((n & 0b1100) == 0b1100)


/************************************************/

// RCT[{̒pX(}CNb)
#define	SERVO_NEUTRAL	1500 
// RCT[{̃pX̍őψʗ(}CNb)
#define	SERVO_MINMAX	500


/************************************************/

void pinMode(byte, byte) ;
void digitalWrite(byte, int) ;
int digitalRead(byte) ;
void bitOut(byte, int) ;
int bitIn(byte) ;

#define	MSBFIRST	1
#define	LSBFIRST	0

void shiftOut(byte, byte, byte, byte) ;

int analogRead(byte) ;
void analogWrite(byte, int) ;
void analogReference(byte) ;

#define	DEFAULT	0
#define	EXTERNAL	1


/************************************************/

void delayMicroseconds(unsigned int) ;
void delayMilliseconds(unsigned int) ;

unsigned long millis() ;


/************************************************/

void isrFunc() ;

#define	interrupts()	{ SRbits.IPL=2; }
#define	noInterrupts()	{ SRbits.IPL=7; }


/************************************************/

#ifdef OPTIMIZE
void isr_optShiftOut(byte, byte) ;
#endif

void isr_pinMode(byte, byte) ;
void isr_bitOut(byte, int) ;
int isr_bitIn(byte) ;
void isr_shiftOut(byte, byte, byte, byte) ;


/************************************************/

#if defined(DUO_GL128_PIC24F)
void SW_init(void) ;
byte SW_read(byte) ;

/* 荞ݒɗp */
void isr_SW_update(void) ;
#endif

/************************************************/

void setup(void) ;
void loop(void) ;


/************************************************/

#ifdef DUO_GL128_PIC24F
#if !(defined(__PIC24FJ64GA002__))
#error MCU`bv̐ݒ肪ԈĂ܂
#endif

#include "duo-gl128-pic24f.h"

#ifndef USE_GLCD
#define	USE_GLCD
#endif

#ifndef USE_FONT
#define	USE_FONT
#endif

#ifdef USE_CLCD
#undef USE_CLCD
#endif

#ifdef USE_SEG7
#undef USE_SEG7
#endif

#ifdef USE_DML
#undef USE_DML
#endif

#endif

#ifdef PIC24F_MOD_GA002U
#if !(defined(__PIC24FJ64GA002__))
#error MCU`bv̐ݒ肪ԈĂ܂
#endif

#include "pic24f-mod-ga002u.h"
#endif

#ifdef PIC24F_MOD_GA004
#if !(defined(__PIC24FJ64GA004__))
#error MCU`bv̐ݒ肪ԈĂ܂
#endif

#include "pic24f-mod-ga004.h"
#endif


/************************************************/

#include "pic24timer.h"
#include "pic24serial.h"
#include "pic24glcd.h"
#include "pic24clcd.h"
#include "pic24seg7.h"
#include "pic24dml.h"


#endif /*PICSYS24_H_*/
